/*

  This is a part of LSDynamic.dll source code.
  
  Copyright (C) 2001-2002 Sylvain Rouquette
  rouque_s@epita.fr
  http://www.epita.fr:8000/~rouque_s

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include "LSDynamic.h"

CDynType::CDynType():
type(dyn_linear),
is_running(0),
has_hwnd(false), has_caption(false),
cur_time(0), start_time(0), end_time(0)
{
	hwnd = string("ShortcutClass");
}

/************************************************************************************/

CDynType::CDynType(const class CDynType &dyn)
{
	type		= dyn.type;
	cur_time	= dyn.cur_time;
	start_time	= dyn.start_time;
	end_time	= dyn.end_time;
	name		= dyn.name;
	hwnd		= dyn.hwnd;
	has_hwnd	= dyn.has_hwnd;
	has_caption	= dyn.has_caption;

	copyCaption(static_cast<CaptionList>(dyn.caption));
}

/************************************************************************************/

CDynType& CDynType::operator=(const CDynType& dyn)
{
	type		= dyn.type;
	cur_time	= dyn.cur_time;
	start_time	= dyn.start_time;
	end_time	= dyn.end_time;
	name		= dyn.name;
	hwnd		= dyn.hwnd;
	has_hwnd	= dyn.has_hwnd;
	has_caption	= dyn.has_caption;

	copyCaption(static_cast<CaptionList>(dyn.caption));

	return (*this);
}

/************************************************************************************/

void CDynType::getCaption(const char *arguments)
{
	_TCHAR command[MAX_LINE_LENGTH];
	LPCTSTR nextCommand = arguments;
	CCaption *cap;

	has_caption = true;
	while (GetToken(nextCommand, command, &nextCommand, true))
		caption.push_back(cap = new CCaption(command));
}

/************************************************************************************/

void CDynType::copyCaption(CaptionList &captions)
{
	if (!captions.empty())
	{
		CCaption *cap;
		has_caption = true;
		for (CaptionListIterator it = captions.begin(); it != captions.end(); it++)
			caption.push_back(cap = new CCaption(**it));
	}
}

/************************************************************************************/

void CDynType::getHWND(const char *token)
{
	if (stricmp(token, "caption") != 0)
	{
		has_hwnd = true;
		hwnd = string(token);
	}
}

/************************************************************************************/

CDynType::~CDynType()
{
	if (!caption.empty())
	{
		for (CaptionListIterator it = caption.begin(); it != caption.end(); it++)
			delete (*it);
		caption.clear();
	}
}
